<template>
    <div class="team">
        <q-page class="row background-content">
            <div class="col-12">
                <div class="row q-pa-md">
                    <div class="col-5 col-md-2 col-lg-2">
                        <div class="title items-center text-center">
                            <p
                                class="
                                    title-text
                                    helvetica-neue-medium
                                    q-pa-lg q-mb-none
                                "
                            >
                                {{ $t('team.title') }}
                            </p>
                        </div>
                    </div>
                    <!-- MOBILE VIEW -->
                    <div class="col-5 row justify-end items-center lt-md">
                        <auto-assign
                            class="row justify-end q-mt-sm items-center"
                        />
                    </div>
                    <div class="col-2 row justify-center items-center lt-md">
                        <notifications
                            v-if="windowWidth <= 450"
                            class="row justify-end q-mt-sm items-center"
                        />
                    </div>
                    <div
                        class="
                            col-12 col-md-7
                            q-pl-md-md
                            row
                            justify-start
                            items-center
                        "
                    >
                        <q-tabs
                            v-model="tab"
                            class="items-center"
                            active-color="none"
                            indicator-color="transparent"
                            align="center"
                            narrow-indicator
                        >
                            <!-- MEMBER -->
                            <q-tab
                                class="
                                    row
                                    justify-center
                                    tab-menu
                                    items-center
                                    q-pa-sm
                                "
                                flat
                                no-caps
                                name="member"
                                :label="$t('team.member')"
                                items-center
                            />
                            <!-- PENDING -->
                            <q-tab
                                class="
                                    row
                                    justify-center
                                    tab-menu
                                    items-center
                                    q-pa-sm
                                "
                                flat
                                no-caps
                                name="pending"
                                :label="$t('team.pending')"
                                items-center
                            />
                        </q-tabs>
                    </div>
                    <div class="col-2 row justify-end items-center gt-sm">
                        <auto-assign />
                    </div>
                    <div
                        class="
                            col-1
                            row
                            justify-center
                            items-center
                            q-pr-lg
                            gt-sm
                        "
                    >
                        <notifications v-if="windowWidth > 450" />
                    </div>
                </div>

                <div class="row q-px-md">
                    <div class="col-12">
                        <div
                            class="page-content no-scroll items-center q-pb-lg"
                        >
                            <q-tab-panels
                                v-model="tab"
                                animated
                                class="bg-transparent"
                            >
                                <!-- MEMBER -->
                                <q-tab-panel name="member">
                                    <!-- home page -->
                                    <div
                                        class="team-home"
                                        v-if="state.currentPage == 'team-home'"
                                    >
                                        <div class="row">
                                            <div class="col-md-4 col-12">
                                                <q-input
                                                    outlined
                                                    bottom-slots
                                                    v-model="search"
                                                    :label="$t('team.search')"
                                                    :loading="
                                                        state.loadingState
                                                    "
                                                    debounce="500"
                                                    bg-color="transparent"
                                                    clearable
                                                    class="border-radius-10"
                                                >
                                                    <template v-slot:prepend>
                                                        <q-icon
                                                            name="search"
                                                            class="text-5B9ADD"
                                                        />
                                                    </template>
                                                </q-input>
                                            </div>
                                        </div>

                                        <!-- MEMBER LIST -->
                                        <div class="row">
                                            <div
                                                class="
                                                    col-md-3 col-12
                                                    q-pr-md-md q-pb-md
                                                "
                                                v-for="(
                                                    member, index
                                                ) in state.memberList"
                                                :key="'member-' + index"
                                            >
                                                <q-item
                                                    dark
                                                    bordered
                                                    class="
                                                        bg-member
                                                        my-card
                                                        border-radius-20
                                                    "
                                                >
                                                    <q-item-section
                                                        avatar
                                                        class="q-py-md"
                                                        @click="
                                                            selectCurrentPage(
                                                                'team-profile',
                                                                member
                                                            )
                                                        "
                                                    >
                                                        <q-img
                                                            class="
                                                                border-radius-50
                                                                pointer
                                                            "
                                                            :src="
                                                                member.user
                                                                    .imageUrl
                                                                    ? member
                                                                          .user
                                                                          .imageUrl
                                                                    : '/images/default.png'
                                                            "
                                                            width="100px"
                                                            height="100px"
                                                        />
                                                    </q-item-section>
                                                    <q-item-section>
                                                        <div
                                                            class="
                                                                text-h6
                                                                pointer
                                                            "
                                                            @click="
                                                                selectCurrentPage(
                                                                    'team-profile',
                                                                    member
                                                                )
                                                            "
                                                        >
                                                            {{
                                                                member.user.name
                                                            }}
                                                        </div>
                                                        <div class="q-select">
                                                            <q-select
                                                                @update:model-value="
                                                                    changeRole(
                                                                        $event,
                                                                        member.id
                                                                    )
                                                                "
                                                                bg-color="blue-2"
                                                                :dense="dense"
                                                                outlined
                                                                v-model="
                                                                    member.role
                                                                "
                                                                :options="
                                                                    roleList
                                                                "
                                                                option-value="id"
                                                                option-label="name"
                                                            />
                                                        </div>
                                                    </q-item-section>
                                                    <q-item-section avatar top>
                                                        <q-btn
                                                            color="white"
                                                            round
                                                            flat
                                                            icon="more_horiz"
                                                        >
                                                            <q-menu
                                                                cover
                                                                auto-close
                                                                class="
                                                                    border-radius-20
                                                                "
                                                            >
                                                                <q-list>
                                                                    <q-item
                                                                        clickable
                                                                        @click="
                                                                            removeMember(
                                                                                member.id
                                                                            )
                                                                        "
                                                                    >
                                                                        <q-item-section
                                                                            avatar
                                                                        >
                                                                            <q-icon
                                                                                color="red"
                                                                                name="remove_circle"
                                                                            />
                                                                        </q-item-section>
                                                                        <q-item-section>
                                                                            {{
                                                                                $t(
                                                                                    'button.remove'
                                                                                )
                                                                            }}
                                                                        </q-item-section>
                                                                    </q-item>
                                                                </q-list>
                                                            </q-menu>
                                                        </q-btn>
                                                    </q-item-section>
                                                </q-item>
                                            </div>
                                        </div>
                                    </div>

                                    <!-- profile page -->
                                    <div
                                        class="team-container team-profile"
                                        v-if="
                                            state.currentPage == 'team-profile'
                                        "
                                    >
                                        <div class="row col-12">
                                            <div
                                                class="
                                                    offset-md-2
                                                    col-md-1
                                                    text-right
                                                    font-18
                                                    text-black
                                                    q-pt-lg q-mt-md-lg
                                                "
                                            >
                                                <q-btn
                                                    flat
                                                    no-caps
                                                    @click="
                                                        selectCurrentPage(
                                                            'team-home'
                                                        )
                                                    "
                                                >
                                                    <q-icon
                                                        name="arrow_back"
                                                        color="black"
                                                        size="25px"
                                                    />
                                                    <span
                                                        class="
                                                            font-18
                                                            helvetica-neue-medium
                                                            q-pl-md
                                                        "
                                                    >
                                                        {{ $t('button.back') }}
                                                    </span>
                                                </q-btn>
                                            </div>
                                            <div
                                                class="
                                                    col-12 col-md-6
                                                    q-pl-xs
                                                    font-18
                                                    text-black
                                                    q-mt-md
                                                "
                                            >
                                                <member-history
                                                    :member="
                                                        state.selectedMemberInfo
                                                    "
                                                />
                                            </div>
                                        </div>
                                    </div>
                                </q-tab-panel>

                                <!-- PENDING -->
                                <q-tab-panel name="pending" class="pending">
                                    <div class="row">
                                        <div class="col-md-4 col-12">
                                            <q-input
                                                outlined
                                                bottom-slots
                                                v-model="pendingSearch"
                                                :label="$t('team.search')"
                                                :loading="state.loadingState"
                                                debounce="500"
                                                bg-color="transparent"
                                                clearable
                                                class="border-radius-10"
                                            >
                                                <template v-slot:prepend>
                                                    <q-icon
                                                        name="search"
                                                        class="text-5B9ADD"
                                                    />
                                                </template>
                                            </q-input>
                                        </div>
                                    </div>

                                    <!-- PENDING LIST -->
                                    <div class="row">
                                        <div
                                            class="
                                                col-md-3 col-12
                                                q-pr-md-md q-pb-md
                                            "
                                            v-for="(
                                                member, index
                                            ) in state.pendingList"
                                            :key="'pending-' + index"
                                        >
                                            <q-item
                                                dark
                                                bordered
                                                class="
                                                    bg-member
                                                    my-card
                                                    border-radius-20
                                                "
                                            >
                                                <q-item-section
                                                    avatar
                                                    class="q-py-md"
                                                    @click="
                                                        pagePressed(member.id)
                                                    "
                                                >
                                                    <q-img
                                                        class="
                                                            border-radius-50
                                                            opacity-5
                                                            pointer
                                                        "
                                                        :src="
                                                            member.user.imageUrl
                                                                ? member.user
                                                                      .imageUrl
                                                                : '/images/default.png'
                                                        "
                                                        width="100px"
                                                        height="100px"
                                                    />
                                                </q-item-section>
                                                <q-item-section>
                                                    <div
                                                        class="
                                                            text-h6 text-4586E1
                                                        "
                                                    >
                                                        {{ member.user.name }}
                                                    </div>
                                                    <div
                                                        class="
                                                            text-subtitle2
                                                            text-8CC4FF
                                                            font-18
                                                            letter-spacing-2
                                                        "
                                                    >
                                                        {{ $t('team.invited') }}
                                                    </div>
                                                </q-item-section>
                                                <q-item-section avatar top>
                                                    <q-btn
                                                        color="red"
                                                        round
                                                        flat
                                                        icon="highlight_off"
                                                    >
                                                        <q-menu
                                                            cover
                                                            auto-close
                                                            class="
                                                                border-radius-20
                                                            "
                                                        >
                                                            <q-list>
                                                                <q-item
                                                                    clickable
                                                                    @click="
                                                                        removePendingMember(
                                                                            member.id
                                                                        )
                                                                    "
                                                                >
                                                                    <q-item-section
                                                                        avatar
                                                                    >
                                                                        <q-icon
                                                                            color="red"
                                                                            name="remove_circle"
                                                                        />
                                                                    </q-item-section>
                                                                    <q-item-section>
                                                                        {{
                                                                            $t(
                                                                                'button.remove'
                                                                            )
                                                                        }}
                                                                    </q-item-section>
                                                                </q-item>
                                                            </q-list>
                                                        </q-menu>
                                                    </q-btn>
                                                </q-item-section>
                                            </q-item>
                                        </div>
                                    </div>
                                </q-tab-panel>
                            </q-tab-panels>
                        </div>
                    </div>
                </div>
            </div>
        </q-page>
    </div>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-call */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
import { useStore } from 'src/store';
import { useRouter } from 'vue-router';
import {
    defineComponent,
    ref,
    reactive,
    computed,
    watch,
    onMounted
} from 'vue';
import { MemberListResponseResult } from 'src/services/responses/member/MemberListResponse';
import Notifications from 'src/components/commons/Notifications.vue';
import AutoAssign from 'src/components/commons/AutoAssign.vue';
import MemberHistory from 'src/components/team/MemberHistory.vue';
import { mapGetters } from 'vuex';
import { useWindowSize } from 'vue-window-size';

export default defineComponent({
    name: 'TeamIndex',
    components: { Notifications, AutoAssign, MemberHistory },
    computed: {
        ...mapGetters({
            getRoles: 'role/getRole'
        })
    },
    setup() {
        // store
        const store = useStore();

        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });
        // router
        const router = useRouter();

        // data
        let search = ref('');
        let pendingSearch = ref('');

        let state = reactive({
            loadingState: ref(false),
            searchList: [] as any,
            pendingList: [] as any,
            memberList: [] as any,
            roles: [] as any,
            currentPage: 'team-home',
            selectedMember: '',
            selectedMemberInfo: {} as any
        });

        const { width, height } = useWindowSize();

        // computed
        const memberListRemoved = computed(() => {
            return store.state.member.removed;
        });

        const memberPendingListRemoved = computed(() => {
            return store.state.member.pendingRemoved;
        });

        const roleList = computed(() => {
            return store.state.role.role;
        });

        // watch
        watch(search, async (currentValue) => {
            if (currentValue) {
                await searchFunction(currentValue, 1);
            } else {
                getMembers();
                state.loadingState = false;
            }
        });

        watch(pendingSearch, async (currentValue) => {
            if (currentValue) {
                await searchFunction(currentValue, 0);
            } else {
                getMembers();
                state.loadingState = false;
            }
        });

        watch(memberListRemoved, () => {
            store.commit('member/setRemoved', false);
            updateMemberList(store.state.member.list, 1);
        });

        watch(memberPendingListRemoved, () => {
            store.commit('member/setPendingRemoved', false);
            updateMemberList(store.state.member.pendingList, 0);
        });

        watch(selectedBusinessId, () => {
            getMembers();
        });

        // methods
        const searchFunction = async (search: string, status: number) => {
            if (store.state.role.permissions.member?.list) {

                state.loadingState = true;

                const result: MemberListResponseResult = await store.dispatch(
                    'member/getList',
                    {
                        status,
                        keyword: search
                    }
                );

                if (result.members.length > 0) {
                    state.loadingState = false;
                    if (status == 1) {
                        state.memberList = result.members;
                    } else {
                        state.pendingList = result.members;
                    }
                } else {
                    if (status == 1) {
                        state.memberList = result.members;
                    } else {
                        state.pendingList = result.members;
                    }
                    state.loadingState = false;
                }
            }
        };

        const getMembers = () => {
            const res = store.state.member.list;

            if (res) {
                state.memberList = res;
            }

            const resPending = store.state.member.pendingList;

            if (resPending) {
                state.pendingList = resPending;
            }
        };

        const removeMember = async (id: string) => {
            if (store.state.role.permissions.member?.delete) {
                await store.dispatch('member/delete', {
                    memberId: id
                });
            }
        };

        const removePendingMember = async (id: string) => {
            if (store.state.role.permissions.member?.delete) {
                await store.dispatch('member/delete', {
                    type: 0,
                    memberId: id
                });
            }
        };

        const updateMemberList = (result: any, status: number) => {
            if (status == 1) {
                state.memberList = result;
            } else {
                state.pendingList = result;
            }
        };

        const changeRole = async (role: any, memberId: string) => {
            if (store.state.role.permissions.member?.update) {
                await store.dispatch('member/update', {
                    memberId,
                    roleId: role.id
                });
            }
        };

        const selectCurrentPage = (page: string, member?: any) => {
            state.currentPage = page;
            state.selectedMember = member.id ?? '';
            state.selectedMemberInfo = member ?? '';
        };

        onMounted(getMembers);

        return {
            state,
            search,
            pendingSearch,
            tab: ref('member'),
            dense: ref(true),
            getMembers,
            removeMember,
            removePendingMember,
            roleList,
            changeRole,
            selectCurrentPage,
            selectedBusinessId,
            windowWidth: width
        };
    }
});
</script>
